/* --------------------------------------------------------------- */
/* -- Copyright (c) 1996 Computer Sciences Department,          -- */
/* -- University of Wisconsin-Madison, subject to the terms     -- */
/* -- and conditions given in the file COPYRIGHT.  All Rights   -- */
/* -- Reserved.                                                 -- */
/* --------------------------------------------------------------- */
/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /p/shore/shore_cvs/src/sdl/lex.yy.C,v 1.2 1996/07/26 00:16:40 nhall Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5



/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
class istream;
#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
	{
	istream* yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};


/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer



static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)

typedef unsigned char YY_CHAR;
#define yytext_ptr yytext
#define YY_INTERACTIVE

#include <FlexLexer.h>


/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 161
#define YY_END_OF_BUFFER 162
static yyconst short int yy_accept[515] =
    {   0,
        0,    0,  162,  160,    3,    2,    2,    1,  110,  160,
       68,   67,  160,   54,   55,   64,   62,   53,   63,   87,
       65,  154,  154,   51,   50,   60,   66,   61,  151,   56,
      160,   57,   73,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,   58,   69,   59,   70,   88,    0,  157,
        0,  115,    0,  156,    0,   74,   75,   93,  123,    0,
      152,  154,    0,    0,   52,   86,   71,   91,   89,   90,
       92,   72,  151,    0,  151,  151,  151,  151,  151,   15,
      151,  151,  151,  151,  129,  151,  151,  151,  151,  151,

      135,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,   31,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  138,  151,
      116,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  145,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  117,  157,  156,    0,    0,  152,
        0,    0,  153,  155,    0,  159,  108,   16,  114,   76,
      151,  151,  151,   99,   45,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,

      122,  151,  151,  151,  151,  151,  151,  151,  151,   22,
      151,  151,  151,  151,  151,   98,   97,  113,  151,  148,
      109,  151,  151,  151,  151,  151,   32,  151,  151,  151,
      151,  151,  151,  151,   43,  151,  151,  151,   46,  151,
      151,  151,   96,  151,  151,  151,  151,  151,  151,  151,
      151,   14,  151,  151,  151,  151,    0,  158,    0,  152,
      151,  151,  151,  151,   38,   78,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  132,
      151,   10,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  125,  151,  151,  151,  151,  151,  151,  140,  151,

       23,  102,  111,   47,   79,   44,  151,  151,  151,  151,
      147,  133,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  127,  151,  151,  151,  151,  150,
      151,  151,  151,  151,  151,  151,  151,   85,  151,  130,
      144,   41,  151,  151,  134,  151,    9,  151,   95,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  149,  101,  151,   82,  151,  128,  151,  136,
       33,  151,  151,  151,  151,  151,  151,  151,   77,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,   80,  151,  151,  151,  151,  119,  151,    8,  151,

      151,  151,  146,  126,  151,  151,  151,  151,  131,  151,
       94,  141,  151,   35,  151,   81,  151,   11,  120,   13,
       24,  151,  121,   12,  139,  151,  151,  151,  151,  151,
        5,  151,   36,  151,  151,  151,  151,  151,   19,   34,
      151,  151,  124,  151,   49,    7,   40,  151,  151,  104,
      151,  143,  151,   84,  151,   37,   39,  142,  151,  100,
      107,  151,  151,   28,  151,  151,  151,  151,  151,  151,
       20,  151,  151,  151,  151,  151,    6,    0,  151,  151,
      151,  103,  151,  151,  105,  151,  151,   29,   30,  151,
      151,   26,  151,   42,  151,    0,   83,   25,  137,    4,

      112,  106,   48,  151,   21,  151,   18,    0,   17,  151,
      118,  151,   27,    0
    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    6,    7,    1,    1,    8,    9,   10,   11,
       12,   13,   14,   15,   16,   17,   18,   19,   20,   20,
       20,   20,   20,   20,   20,   20,   20,   21,   22,   23,
       24,   25,    1,    1,   26,   26,   26,   26,   27,   26,
       28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
       28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
       29,   30,   31,   32,   33,    1,   34,   35,   36,   37,

       38,   39,   40,   41,   42,   28,   43,   44,   45,   46,
       47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
       57,   28,   58,   59,   60,   61,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[62] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
        1,    1,    1,    1,    1,    2,    2,    3,    1,    1,
        1,    1,    3,    2,    2,    2,    2,    2,    2,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    1,    1,    1,
        1
    } ;

static yyconst short int yy_base[522] =
    {   0,
        0,    0,  572,  573,  573,  573,  573,  573,  547,   55,
      573,  561,   53,  573,  573,  573,  545,  573,   40,  551,
      554,   49,   53,   50,  573,   54,  542,   57,    0,  573,
      552,  573,  573,   49,   41,   68,   69,   50,   79,  514,
       44,  525,   80,   86,   89,   96,   87,  100,  107,  108,
      105,  515,  122,  573,  502,  573,  573,  573,  117,  573,
      136,  573,  142,  573,  147,  573,  573,  573,  573,  547,
      148,  154,  164,    0,  573,  573,  573,  573,  573,  573,
      573,  573,    0,  556,  507,  513,  132,  508,  505,    0,
      502,  513,  512,  504,    0,  499,  515,   39,   64,  510,

        0,  143,  140,  494,  499,  507,  491,  157,  499,  492,
      151,  491,  493,  492,  490,  159,  480,  485,  152,  489,
      496,  477,  486,  494,  486,  485,  476,  475,   97,  488,
      488,  472,  485,  472,  155,  486,  478,  173,  170,  472,
      468,  467,  471,  473,    0,  167,  466,  465,  128,  475,
      162,  469,  472,  457,  573,  201,  205,  495,  489,  205,
      207,  209,  214,    0,  503,  573,    0,    0,    0,    0,
      461,  470,  453,    0,    0,  458,  463,  450,  448,  447,
      185,  451,  462,  196,  457,  442,  455,  440,  456,  442,
      444,  443,  449,  435,  438,  446,  432,  431,  429,  446,

      445,  433,  424,  429,  437,  421,  435,  201,  434,  420,
      418,  431,  416,  427,  427,    0,    0,  412,  412,    0,
        0,  425,  407,  404,  414,  421,    0,  408,  406,  402,
      403,  410,  402,  415,    0,  417,  412,  396,    0,  398,
      395,  198,    0,  394,  399,  406,  399,  404,  169,  399,
      406,    0,  393,  401,  387,  395,  422,  573,  222,  225,
      377,  376,  390,  393,    0,    0,  392,  377,  376,  389,
      374,  373,  371,  377,  370,  371,  384,  377,  374,    0,
      379,    0,  368,  363,  364,  367,  374,  359,  358,  357,
      364,    0,  359,  356,  349,  352,  353,  352,    0,  351,

        0,    0,    0,  200,    0,    0,  356,  357,  346,  363,
        0,    0,  346,  345,  352,  359,  354,  349,  352,  342,
      336,  351,  348,  333,    0,  338,  347,  346,  330,    0,
      342,  342,  332,  324,  336,  323,  334,    0,  335,    0,
        0,    0,  337,  337,    0,  332,    0,  313,    0,  330,
      323,  328,  327,  317,  311,  316,  323,  314,  307,  307,
      305,  304,    0,    0,  317,    0,  310,    0,  301,    0,
        0,  300,  137,  300,  299,  302,  310,  303,    0,  289,
      312,  302,  292,  290,  305,  304,  288,  292,  295,  284,
      289,    0,  294,  281,  291,  289,    0,  292,    0,  291,

      282,  289,    0,    0,  273,  279,  274,  271,    0,  270,
        0,    0,  264,    0,  284,    0,  267,    0,    0,    0,
        0,  272,    0,    0,    0,  283,  278,  277,  276,  262,
        0,  270,    0,  276,  273,  257,  270,  255,    0,    0,
      262,  258,    0,  268,    0,    0,    0,  265,  263,  296,
      262,    0,  247,    0,  260,    0,    0,    0,  245,    0,
        0,  260,  259,    0,  242,  255,  241,  234,  252,  251,
        0,  250,  230,  240,  247,  238,    0,  232,  245,  243,
      243,    0,  241,  226,    0,  225,  224,    0,    0,  229,
      237,    0,  222,    0,  220,  233,    0,    0,    0,    0,

        0,    0,    0,  218,    0,  209,    0,  197,    0,  204,
      573,   60,    0,  573,  252,  255,  257,  260,   65,  263,
      266
    } ;

static yyconst short int yy_def[522] =
    {   0,
      514,    1,  514,  514,  514,  514,  514,  514,  514,  515,
      514,  514,  516,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  517,  514,
      514,  514,  514,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  514,  514,  514,  514,  514,  515,  514,
      515,  514,  516,  514,  516,  514,  514,  514,  514,  518,
      514,  514,  514,  519,  514,  514,  514,  514,  514,  514,
      514,  514,  517,  520,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,

      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  514,  515,  516,  518,  521,  514,
      514,  514,  514,  519,  520,  514,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,

      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  518,  514,  514,  514,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,

      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,

      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  514,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  514,  517,  517,  517,  517,

      517,  517,  517,  517,  517,  517,  517,  514,  517,  517,
      514,  517,  517,    0,  514,  514,  514,  514,  514,  514,
      514
    } ;

static yyconst short int yy_nxt[635] =
    {   0,
        4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
       14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
       24,   25,   26,   27,   28,   29,   29,   29,   30,   31,
       32,   33,    4,   34,   35,   36,   37,   38,   39,   40,
       29,   41,   42,   43,   44,   45,   46,   47,   29,   48,
       49,   50,   51,   52,   53,   29,   29,   54,   55,   56,
       57,   60,   64,   67,   68,   71,  164,   72,   72,   71,
       75,   72,   72,   76,   93,   73,   77,   78,   79,   73,
       81,   82,   65,   85,   61,  179,   73,   94,  115,  116,
       73,  180,   86,  106,   87,  107,   88,   95,   89,   90,

       91,   96,   92,  101,   74,  108,  102,  513,   97,  181,
      103,   98,  109,  118,   99,  104,  182,  100,  105,  122,
      110,  119,  111,   60,  134,  112,  120,  123,  113,  121,
      126,  128,  124,  137,  223,  127,  135,  138,  125,  136,
      224,  129,  156,  130,  139,  131,   61,  140,  132,  133,
      149,   64,  150,  141,  145,  151,  157,  146,  142,  143,
      147,  144,  153,  154,  148,   61,  160,  160,  169,  249,
       71,   65,   72,   72,  161,  426,   65,  162,  250,  162,
       73,  184,  163,  163,  199,  161,  185,  427,  170,  187,
      188,   73,  193,  186,  212,  205,  230,  200,  194,  252,

      245,  231,  213,  253,  195,  206,  234,   60,  196,  207,
      208,  235,  209,  237,   64,  333,  236,  334,  238,  246,
      259,  239,  259,  160,  160,  260,  260,  163,  163,  273,
       61,  161,  163,  163,   65,  269,  270,  274,  298,  326,
      260,  260,  161,  260,  260,  512,  375,  299,  511,  510,
      327,  376,   59,   59,   59,   63,   63,   63,   83,   83,
      158,  158,  158,  165,  165,  165,  257,  257,  257,  509,
      508,  507,  506,  505,  504,  503,  502,  501,  500,  499,
      498,  497,  496,  495,  494,  493,  492,  491,  490,  489,
      488,  487,  486,  485,  484,  483,  482,  481,  480,  479,

      478,  477,  476,  475,  474,  473,  472,  471,  470,  469,
      468,  467,  466,  465,  464,  463,  462,  461,  460,  459,
      458,  457,  456,  455,  454,  453,  452,  451,  450,  449,
      448,  447,  446,  445,  444,  443,  442,  441,  440,  439,
      438,  437,  436,  435,  434,  433,  432,  431,  430,  429,
      428,  425,  424,  423,  422,  421,  420,  419,  418,  417,
      416,  415,  414,  413,  412,  411,  410,  409,  408,  407,
      406,  405,  404,  403,  402,  401,  400,  399,  398,  397,
      396,  395,  394,  393,  392,  391,  390,  389,  388,  387,
      386,  385,  384,  383,  382,  381,  380,  379,  378,  377,

      374,  373,  372,  371,  370,  369,  368,  367,  366,  365,
      364,  363,  362,  361,  360,  359,  358,  357,  356,  355,
      354,  353,  352,  351,  350,  349,  348,  347,  346,  345,
      344,  343,  342,  341,  159,  340,  339,  338,  337,  336,
      335,  332,  331,  330,  329,  328,  325,  324,  323,  322,
      321,  320,  319,  318,  317,  316,  315,  314,  313,  312,
      311,  310,  309,  308,  307,  306,  305,  304,  303,  302,
      301,  300,  297,  296,  295,  294,  293,  292,  291,  290,
      289,  288,  287,  286,  285,  284,  283,  282,  281,  280,
      279,  278,  277,  276,  275,  272,  271,  268,  267,  266,

      265,  264,  263,  262,  261,  166,  258,  159,  256,  255,
      254,  251,  248,  247,  244,  243,  242,  241,  240,  233,
      232,  229,  228,  227,  226,  225,  222,  221,  220,  219,
      218,  217,  216,  215,  214,  211,  210,  204,  203,  202,
      201,  198,  197,  192,  191,  190,  189,  183,  178,  177,
      176,  175,  174,  173,  172,  171,  168,  167,  166,  159,
      155,  152,  117,  114,   84,   80,   70,   69,   66,   62,
       58,  514,    3,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,

      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514
    } ;

static yyconst short int yy_chk[635] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,   10,   13,   19,   19,   22,  519,   22,   22,   23,
       24,   23,   23,   24,   35,   22,   26,   26,   26,   23,
       28,   28,   13,   34,   10,   98,   22,   35,   41,   41,
       23,   98,   34,   38,   34,   38,   34,   35,   34,   34,

       34,   36,   34,   37,   22,   38,   37,  512,   36,   99,
       37,   36,   39,   43,   36,   37,   99,   36,   37,   44,
       39,   43,   39,   59,   47,   39,   43,   44,   39,   43,
       45,   46,   44,   48,  129,   45,   47,   48,   44,   47,
      129,   46,   61,   46,   49,   46,   59,   49,   46,   46,
       51,   63,   51,   49,   50,   51,   65,   50,   49,   49,
       50,   49,   53,   53,   50,   61,   71,   71,   87,  149,
       72,   63,   72,   72,   71,  373,   65,   73,  149,   73,
       72,  102,   73,   73,  111,   71,  102,  373,   87,  103,
      103,   72,  108,  102,  119,  116,  135,  111,  108,  151,

      146,  135,  119,  151,  108,  116,  138,  156,  108,  116,
      116,  138,  116,  139,  157,  249,  138,  249,  139,  146,
      161,  139,  161,  160,  160,  161,  161,  162,  162,  184,
      156,  160,  163,  163,  157,  181,  181,  184,  208,  242,
      259,  259,  160,  260,  260,  510,  304,  208,  508,  506,
      242,  304,  515,  515,  515,  516,  516,  516,  517,  517,
      518,  518,  518,  520,  520,  520,  521,  521,  521,  504,
      496,  495,  493,  491,  490,  487,  486,  484,  483,  481,
      480,  479,  478,  476,  475,  474,  473,  472,  470,  469,
      468,  467,  466,  465,  463,  462,  459,  455,  453,  451,

      450,  449,  448,  444,  442,  441,  438,  437,  436,  435,
      434,  432,  430,  429,  428,  427,  426,  422,  417,  415,
      413,  410,  408,  407,  406,  405,  402,  401,  400,  398,
      396,  395,  394,  393,  391,  390,  389,  388,  387,  386,
      385,  384,  383,  382,  381,  380,  378,  377,  376,  375,
      374,  372,  369,  367,  365,  362,  361,  360,  359,  358,
      357,  356,  355,  354,  353,  352,  351,  350,  348,  346,
      344,  343,  339,  337,  336,  335,  334,  333,  332,  331,
      329,  328,  327,  326,  324,  323,  322,  321,  320,  319,
      318,  317,  316,  315,  314,  313,  310,  309,  308,  307,

      300,  298,  297,  296,  295,  294,  293,  291,  290,  289,
      288,  287,  286,  285,  284,  283,  281,  279,  278,  277,
      276,  275,  274,  273,  272,  271,  270,  269,  268,  267,
      264,  263,  262,  261,  257,  256,  255,  254,  253,  251,
      250,  248,  247,  246,  245,  244,  241,  240,  238,  237,
      236,  234,  233,  232,  231,  230,  229,  228,  226,  225,
      224,  223,  222,  219,  218,  215,  214,  213,  212,  211,
      210,  209,  207,  206,  205,  204,  203,  202,  201,  200,
      199,  198,  197,  196,  195,  194,  193,  192,  191,  190,
      189,  188,  187,  186,  185,  183,  182,  180,  179,  178,

      177,  176,  173,  172,  171,  165,  159,  158,  154,  153,
      152,  150,  148,  147,  144,  143,  142,  141,  140,  137,
      136,  134,  133,  132,  131,  130,  128,  127,  126,  125,
      124,  123,  122,  121,  120,  118,  117,  115,  114,  113,
      112,  110,  109,  107,  106,  105,  104,  100,   97,   96,
       94,   93,   92,   91,   89,   88,   86,   85,   84,   70,
       55,   52,   42,   40,   31,   27,   21,   20,   17,   12,
        9,    3,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,

      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514
    } ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#line 1 "oql_gram.l"
#define INITIAL 0
/****************** LEX **********************************************/
#line 4 "oql_gram.l"
#include <pFlex.h>
#include <defns.h>
#include <Bparsestate.h>
#include "metatypes.sdl.h"
#include <sdl_ext.h>
#include <oql_gram.tab.h>
/** Other than keywords...	**/
/*******************************************************/
/** First the keywords	      	       	     	      **/
/*******************************************************/
#line 646 "lex.yy.cc"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif


#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifndef YY_NO_INPUT
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
#define ECHO LexerOutput( yytext, yyleng )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( (result = LexerInput( (char *) buf, max_size )) < 0 ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) LexerError( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yyFlexLexer::yylex()
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;

#line 26 "oql_gram.l"

#line 771 "lex.yy.cc"

	if ( yy_init )
		{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = &cin;

		if ( ! yyout )
			yyout = &cout;

		if ( ! yy_current_buffer )
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				yy_last_accepting_state = yy_current_state;
				yy_last_accepting_cpos = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 515 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 573 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = yy_hold_char;
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 27 "oql_gram.l"
{}
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 28 "oql_gram.l"
{Bparser_state()->incLine();}
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 29 "oql_gram.l"
{}	
	YY_BREAK
/** Ignore tabs, whitespaces, returns, newlines	**/
/** ODL keywords first...  **/
case 4:
YY_RULE_SETUP
#line 34 "oql_gram.l"
{return INTERFACE;}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 35 "oql_gram.l"
{return MODULE;}
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 36 "oql_gram.l"
{return TYPEDEF;}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 37 "oql_gram.l"
{return STRUCT;}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 38 "oql_gram.l"
{return UNION;}
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 39 "oql_gram.l"
{return CONST;}
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 40 "oql_gram.l"
{return ENUM;}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 41 "oql_gram.l"
{return EXCEPT;}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 43 "oql_gram.l"
{return IMPORT;}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 44 "oql_gram.l"
{return EXPORT;}
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 45 "oql_gram.l"
{return USE;}
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 46 "oql_gram.l"
{return AS;}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 47 "oql_gram.l"
{return ALL;}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 49 "oql_gram.l"
{return PERSISTENT;}
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 50 "oql_gram.l"
{return TRANSIENT;}
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 51 "oql_gram.l"
{return PUBLIC;}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 52 "oql_gram.l"
{return tPRIVATE;}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 53 "oql_gram.l"
{return PROTECTED;}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 54 "oql_gram.l"
{return KEY;}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 55 "oql_gram.l"
{return KEY;}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 56 "oql_gram.l"
{return EXTENT;}
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 57 "oql_gram.l"
{return ATTRIBUTE;}
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 58 "oql_gram.l"
{return READONLY;}
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 59 "oql_gram.l"
{return RELATIONSHIP;}
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 60 "oql_gram.l"
{return INVERSE;}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 61 "oql_gram.l"
{return ORDER_BY;}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 62 "oql_gram.l"
{return OVERRIDE;}
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 63 "oql_gram.l"
{return tIN;}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 64 "oql_gram.l"
{return tOUT;}
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 65 "oql_gram.l"
{return tINOUT;}
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 66 "oql_gram.l"
{return RAISES;}
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 67 "oql_gram.l"
{return DIRECT;}
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 68 "oql_gram.l"
{return ONEWAY;}
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 69 "oql_gram.l"
{return CONTEXT;}
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 71 "oql_gram.l"
{return CASE;}
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 72 "oql_gram.l"
{return DEFAULT;}
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 73 "oql_gram.l"
{return SWITCH;}
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 75 "oql_gram.l"
{return ARRAY;}
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 76 "oql_gram.l"
{return SEQUENCE;}
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 77 "oql_gram.l"
{return tREF;}
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 78 "oql_gram.l"
{return tLREF;}
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 79 "oql_gram.l"
{return tBAG;}
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 80 "oql_gram.l"
{return tSET;}
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 81 "oql_gram.l"
{return LIST;}
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 82 "oql_gram.l"
{return MULTILIST;}
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 83 "oql_gram.l"
{return tSTRING;}
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 85 "oql_gram.l"
{return ';';}
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 86 "oql_gram.l"
{return ':';}
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 87 "oql_gram.l"
{return DCOLON;}
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 88 "oql_gram.l"
{return ',';}
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 89 "oql_gram.l"
{return '(';}
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 90 "oql_gram.l"
{return ')';}
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 91 "oql_gram.l"
{return '[';}
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 92 "oql_gram.l"
{return ']';}
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 93 "oql_gram.l"
{return '{';}
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 94 "oql_gram.l"
{return '}';}
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 95 "oql_gram.l"
{return '<';}
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 96 "oql_gram.l"
{return '>';}
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 98 "oql_gram.l"
{return '+';}
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 99 "oql_gram.l"
{return '-';}
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 100 "oql_gram.l"
{return '*';}
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 101 "oql_gram.l"
{return '/';}
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 102 "oql_gram.l"
{return '=';}
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 103 "oql_gram.l"
{return '&';}
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 104 "oql_gram.l"
{return '%';}
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 105 "oql_gram.l"
{return '|';}
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 106 "oql_gram.l"
{return '~';}
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 107 "oql_gram.l"
{return LSHIFT;}
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 108 "oql_gram.l"
{return RSHIFT;}
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 109 "oql_gram.l"
{return '^';}
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 111 "oql_gram.l"
{return PLUS_EQUAL;}
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 112 "oql_gram.l"
{return MINUS_EQUAL;}
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 114 "oql_gram.l"
{return ANY;}
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 115 "oql_gram.l"
{return OCTET;}
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 116 "oql_gram.l"
{return CHAR;}
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 117 "oql_gram.l"
{return LONG;}
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 118 "oql_gram.l"
{return SHORT;}
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 119 "oql_gram.l"
{return DOUBLE;}
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 120 "oql_gram.l"
{return FLOAT;}
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 121 "oql_gram.l"
{return UNSIGNED;}
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 122 "oql_gram.l"
{return BOOLEAN;}
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 123 "oql_gram.l"
{return VOID;}
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 125 "oql_gram.l"
{return(ASSIGN);}	/* BOLO extension */
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 126 "oql_gram.l"
{return(DOT);}
	YY_BREAK
case 88:
YY_RULE_SETUP
#line 127 "oql_gram.l"
{return(DIFF);}
	YY_BREAK
case 89:
YY_RULE_SETUP
#line 128 "oql_gram.l"
{return(DIFF);}
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 129 "oql_gram.l"
{return('=');}
	YY_BREAK
case 91:
YY_RULE_SETUP
#line 130 "oql_gram.l"
{return(INFEQUAL);}
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 131 "oql_gram.l"
{return(SUPEQUAL);}
	YY_BREAK
case 93:
YY_RULE_SETUP
#line 132 "oql_gram.l"
{return(ARROW);}
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 133 "oql_gram.l"
{return(DEFINE);}
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 134 "oql_gram.l"
{return(COUNT);}
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 135 "oql_gram.l"
{return(SUM);}
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 136 "oql_gram.l"
{return(OQL_MIN);}
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 137 "oql_gram.l"
{return(OQL_MAX);}
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 138 "oql_gram.l"
{return(AVG);}
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 139 "oql_gram.l"
{return(ELT);}
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 140 "oql_gram.l"
{return(FIRST);}
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 141 "oql_gram.l"
{return(LAST);}
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 142 "oql_gram.l"
{return(DISTINCT);}
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 143 "oql_gram.l"
{return(UNIQUE);}
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 144 "oql_gram.l"
{return(LISTOSET);}
	YY_BREAK
case 106:
YY_RULE_SETUP
#line 145 "oql_gram.l"
{return(LISTOSET);}
	YY_BREAK
case 107:
YY_RULE_SETUP
#line 146 "oql_gram.l"
{return(FLATTEN);}
	YY_BREAK
case 108:
YY_RULE_SETUP
#line 147 "oql_gram.l"
{return(OQL_ABS);}
	YY_BREAK
case 109:
YY_RULE_SETUP
#line 148 "oql_gram.l"
{return(NOT);}
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 149 "oql_gram.l"
{return(NOT);}	
	YY_BREAK
case 111:
YY_RULE_SETUP
#line 150 "oql_gram.l"
{return(LIKE);}
	YY_BREAK
case 112:
YY_RULE_SETUP
#line 151 "oql_gram.l"
{return(INTERSECT);}
	YY_BREAK
case 113:
YY_RULE_SETUP
#line 152 "oql_gram.l"
{return('%');}
	YY_BREAK
case 114:
YY_RULE_SETUP
#line 153 "oql_gram.l"
{return(AND);}
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 154 "oql_gram.l"
{return(AND);}
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 155 "oql_gram.l"
{return(OR);}
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 156 "oql_gram.l"
{return(OR);}
	YY_BREAK
case 118:
YY_RULE_SETUP
#line 157 "oql_gram.l"
{return(USET);}
	YY_BREAK
case 119:
YY_RULE_SETUP
#line 158 "oql_gram.l"
{return(TUPLE);}
	YY_BREAK
case 120:
YY_RULE_SETUP
#line 159 "oql_gram.l"
{return(EXISTS);}
	YY_BREAK
case 121:
YY_RULE_SETUP
#line 160 "oql_gram.l"
{return(FORALL);}
	YY_BREAK
case 122:
YY_RULE_SETUP
#line 161 "oql_gram.l"
{return(FOR);}
	YY_BREAK
case 123:
YY_RULE_SETUP
#line 162 "oql_gram.l"
{return(DOTS);}
	YY_BREAK
case 124:
YY_RULE_SETUP
#line 163 "oql_gram.l"
{return(SELECT);}
	YY_BREAK
case 125:
YY_RULE_SETUP
#line 164 "oql_gram.l"
{return(FROM);}
	YY_BREAK
case 126:
YY_RULE_SETUP
#line 165 "oql_gram.l"
{return(WHERE);}
	YY_BREAK
case 127:
YY_RULE_SETUP
#line 166 "oql_gram.l"
{return(SORT);}
	YY_BREAK
case 128:
YY_RULE_SETUP
#line 167 "oql_gram.l"
{return(GROUP);}
	YY_BREAK
case 129:
YY_RULE_SETUP
#line 168 "oql_gram.l"
{return(BY);}
	YY_BREAK
case 130:
YY_RULE_SETUP
#line 169 "oql_gram.l"
{return(WITH);}
	YY_BREAK
case 131:
YY_RULE_SETUP
#line 171 "oql_gram.l"
{return(CREATE);}
	YY_BREAK
case 132:
YY_RULE_SETUP
#line 172 "oql_gram.l"
{return(DROP);}
	YY_BREAK
case 133:
YY_RULE_SETUP
#line 173 "oql_gram.l"
{return(OPEN);}
	YY_BREAK
case 134:
YY_RULE_SETUP
#line 174 "oql_gram.l"
{return(CLOSE);}
	YY_BREAK
case 135:
YY_RULE_SETUP
#line 175 "oql_gram.l"
{return(DB);}
	YY_BREAK
case 136:
YY_RULE_SETUP
#line 176 "oql_gram.l"
{return(tINDEX);}
	YY_BREAK
case 137:
YY_RULE_SETUP
#line 177 "oql_gram.l"
{return(CLUSTERED);}
	YY_BREAK
case 138:
YY_RULE_SETUP
#line 178 "oql_gram.l"
{return(OQL_ON);}
	YY_BREAK
case 139:
YY_RULE_SETUP
#line 180 "oql_gram.l"
{return INSERT;}
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 181 "oql_gram.l"
{return INTO;}
	YY_BREAK
case 141:
YY_RULE_SETUP
#line 182 "oql_gram.l"
{return DELETE;}
	YY_BREAK
case 142:
YY_RULE_SETUP
#line 183 "oql_gram.l"
{return DESTROY;}
	YY_BREAK
case 143:
YY_RULE_SETUP
#line 184 "oql_gram.l"
{return UPDATE;}
	YY_BREAK
case 144:
YY_RULE_SETUP
#line 185 "oql_gram.l"
{return APPLY;}
	YY_BREAK
case 145:
YY_RULE_SETUP
#line 186 "oql_gram.l"
{return TO;}
	YY_BREAK
case 146:
YY_RULE_SETUP
#line 187 "oql_gram.l"
{return USING;}
	YY_BREAK
case 147:
YY_RULE_SETUP
#line 188 "oql_gram.l"
{return ONLY;}
	YY_BREAK
case 148:
YY_RULE_SETUP
#line 190 "oql_gram.l"
{return LEX_OQL_NIL;}
	YY_BREAK
case 149:
YY_RULE_SETUP
#line 191 "oql_gram.l"
{return LEX_FALSE;}
	YY_BREAK
case 150:
YY_RULE_SETUP
#line 192 "oql_gram.l"
{return LEX_TRUE;}
	YY_BREAK
case 151:
YY_RULE_SETUP
#line 193 "oql_gram.l"
{return LEX_ID;}
	YY_BREAK
case 152:
YY_RULE_SETUP
#line 194 "oql_gram.l"
{return LEX_FLOAT_LIT;}
	YY_BREAK
case 153:
YY_RULE_SETUP
#line 195 "oql_gram.l"
{return LEX_FLOAT_LIT;}
	YY_BREAK
case 154:
YY_RULE_SETUP
#line 196 "oql_gram.l"
{return LEX_INT_LIT;}
	YY_BREAK
case 155:
YY_RULE_SETUP
#line 197 "oql_gram.l"
{return LEX_INT_LIT;}
	YY_BREAK
case 156:
YY_RULE_SETUP
#line 198 "oql_gram.l"
{return LEX_CHAR_LIT;}
	YY_BREAK
case 157:
YY_RULE_SETUP
#line 199 "oql_gram.l"
{return LEX_STRING_LIT;}
	YY_BREAK
case 158:
YY_RULE_SETUP
#line 201 "oql_gram.l"
{}
	YY_BREAK
case 159:
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
yy_c_buf_p = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 202 "oql_gram.l"
{}
	YY_BREAK
case 160:
YY_RULE_SETUP
#line 203 "oql_gram.l"
{return ILLEGAL_INPUT;}
	YY_BREAK
case 161:
YY_RULE_SETUP
#line 205 "oql_gram.l"
ECHO;
	YY_BREAK
#line 1664 "lex.yy.cc"
case YY_STATE_EOF(INITIAL):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */

yyFlexLexer::yyFlexLexer( istream* arg_yyin, ostream* arg_yyout )
	{
	yyin = arg_yyin;
	yyout = arg_yyout;
	yy_c_buf_p = 0;
	yy_init = 1;
	yy_start = 0;
	yy_flex_debug = 0;
	yylineno = 1;	// this will only get updated if %option yylineno

	yy_did_buffer_switch_on_eof = 0;

	yy_looking_for_trail_begin = 0;
	yy_more_flag = 0;
	yy_more_len = 0;

	yy_start_stack_ptr = yy_start_stack_depth = 0;
	yy_start_stack = 0;

	yy_current_buffer = 0;

#ifdef YY_USES_REJECT
	yy_state_buf = new yy_state_type[YY_BUF_SIZE + 2];
#else
	yy_state_buf = 0;
#endif
	}

yyFlexLexer::~yyFlexLexer()
	{
	delete yy_state_buf;
	yy_delete_buffer( yy_current_buffer );
	}

void yyFlexLexer::switch_streams( istream* new_in, ostream* new_out )
	{
	if ( new_in )
		{
		yy_delete_buffer( yy_current_buffer );
		yy_switch_to_buffer( yy_create_buffer( new_in, YY_BUF_SIZE ) );
		}

	if ( new_out )
		yyout = new_out;
	}

#ifdef YY_INTERACTIVE
int yyFlexLexer::LexerInput( char* buf, int /* max_size */ )
#else
int yyFlexLexer::LexerInput( char* buf, int max_size )
#endif
	{
	if ( yyin->eof() || yyin->fail() )
		return 0;

#ifdef YY_INTERACTIVE
	yyin->get( buf[0] );

	if ( yyin->eof() )
		return 0;

	if ( yyin->bad() )
		return -1;

	return 1;

#else
	(void) yyin->read( buf, max_size );

	if ( yyin->bad() )
		return -1;
	else
		return yyin->gcount();
#endif
	}

void yyFlexLexer::LexerOutput( const char* buf, int size )
	{
	(void) yyout->write( buf, size );
	}

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

int yyFlexLexer::yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a singled characater, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset =
				(int) (yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_flex_realloc( (void *) b->yy_ch_buf,
							 b->yy_buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

yy_state_type yyFlexLexer::yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			yy_last_accepting_state = yy_current_state;
			yy_last_accepting_cpos = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 515 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

yy_state_type yyFlexLexer::yy_try_NUL_trans( yy_state_type yy_current_state )
	{
	register int yy_is_jam;
	register char *yy_cp = yy_c_buf_p;

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		yy_last_accepting_state = yy_current_state;
		yy_last_accepting_cpos = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 515 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 514);

	return yy_is_jam ? 0 : yy_current_state;
	}


void yyFlexLexer::yyunput( int c, register char* yy_bp )
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;


	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
	}


int yyFlexLexer::yyinput()
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			yytext_ptr = yy_c_buf_p;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						{
						yy_c_buf_p =
						yytext_ptr + YY_MORE_ADJ;
						return EOF;
						}

					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;
					break;

				case EOB_ACT_LAST_MATCH:
#ifdef __cplusplus
					YY_FATAL_ERROR(
					"unexpected last match in yyinput()" );
#else
					YY_FATAL_ERROR(
					"unexpected last match in input()" );
#endif
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;


	return c;
	}


void yyFlexLexer::yyrestart( istream* input_file )
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


void yyFlexLexer::yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


void yyFlexLexer::yy_load_buffer_state()
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


YY_BUFFER_STATE yyFlexLexer::yy_create_buffer( istream* file, int size )
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
	}


void yyFlexLexer::yy_delete_buffer( YY_BUFFER_STATE b )
	{
	if ( ! b )
		return;

	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yy_flex_free( (void *) b->yy_ch_buf );

	yy_flex_free( (void *) b );
	}


extern "C" int isatty YY_PROTO(( int ));
void yyFlexLexer::yy_init_buffer( YY_BUFFER_STATE b, istream* file )

	{
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

	b->yy_is_interactive = 0;
	}


void yyFlexLexer::yy_flush_buffer( YY_BUFFER_STATE b )
	{
	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == yy_current_buffer )
		yy_load_buffer_state();
	}


#ifndef YY_NO_SCAN_BUFFER
#endif


#ifndef YY_NO_SCAN_STRING
#endif


#ifndef YY_NO_SCAN_BYTES
#endif


#ifndef YY_NO_PUSH_STATE
void yyFlexLexer::yy_push_state( int new_state )
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}
#endif


#ifndef YY_NO_POP_STATE
void yyFlexLexer::yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}
#endif


#ifndef YY_NO_TOP_STATE
int yyFlexLexer::yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif


void yyFlexLexer::LexerError( yyconst char msg[] )
	{
	cerr << msg << '\n';
	exit( YY_EXIT_FAILURE );
	}


/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n - YY_MORE_ADJ; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if YY_MAIN
int main()
	{
	yylex();
	return 0;
	}
#endif
#line 205 "oql_gram.l"

/* <<EOF>>	       {return EOI;}  this seems to hose stuff. */
extern "C"
{
int yylex(YYSTYPE* yval)
{
   int x = Bparser_state()->scanner()->yylex();
   yval->string = (char *)(Bparser_state()->scanner()->YYText());
   return x;
}
}
